From 0a17a69a0875957d0a0726a66dae0d4fdf56d100 Mon Sep 17 00:00:00 2001
From: Helmut Grohne <helmut@subdivi.de>
Date: Thu, 18 Dec 2014 14:39:19 -0800
Subject: [PATCH 06/10] Allow target selection via dpkg-buildpackage
 --target-arch. Closes: #773065

---
 debian/rules.defs | 52 +++++++++++++++--------------------------------
 1 file changed, 16 insertions(+), 36 deletions(-)

diff --git a/debian/rules.defs b/debian/rules.defs
index 4875c61..0198007 100644
--- a/debian/rules.defs
+++ b/debian/rules.defs
@@ -34,23 +34,7 @@ vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))
 # for rules.sonames
 vafilt_defined = 1
 
-dpkg_target_vars := $(shell (dpkg-architecture | grep -q DEB_TARGET) && echo yes)
-ifeq ($(dpkg_target_vars),yes)
-  DEB_TARGET_ARCH=
-  DEB_TARGET_ARCH_BITS=
-  DEB_TARGET_ARCH_CPU=
-  DEB_TARGET_ARCH_ENDIAN=
-  DEB_TARGET_ARCH_OS=
-  DEB_TARGET_GNU_CPU=
-  DEB_TARGET_GNU_SYSTEM=
-  DEB_TARGET_GNU_TYPE=
-  DEB_TARGET_MULTIARCH=
-endif
-
 DPKG_VARS		:= $(shell dpkg-architecture)
-ifeq ($(dpkg_target_vars),yes)
-  DPKG_VARS		:= $(filter-out DEB_TARGET_%, $(DPKG_VARS))
-endif
 DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
 DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
 DEB_BUILD_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_MULTIARCH)
@@ -125,7 +109,7 @@ export LIBC_FATAL_STDERR_=1
 
 # ---------------------------------------------------------------------------
 # set target
-# - GNU triplet via DEB_TARGET_GNU_TYPE
+# - dpkg-buildpackage --target-arch (via DEB_TARGET_ARCH)
 # - Debian arch in debian/target
 # - Debian arch via DEB_GCC_TARGET or GCC_TARGET
 #
@@ -133,32 +117,28 @@ export LIBC_FATAL_STDERR_=1
 ifdef GCC_TARGET
   DEB_GCC_TARGET := $(GCC_TARGET)
 endif
-ifdef DEB_TARGET_GNU_TYPE
-  TARGET_VARS := $(shell dpkg-architecture -f -t$(DEB_TARGET_GNU_TYPE) 2>/dev/null)
-else
-  # allow debian/target to be used instead of DEB_GCC_TARGET - this was requested
-  # by toolchain-source maintainer
-  DEBIAN_TARGET_FILE := $(strip $(if $(wildcard debian/target),$(shell cat debian/target 2>/dev/null)))
-  ifndef DEB_TARGET_ARCH
-    ifneq (,$(DEBIAN_TARGET_FILE))
-      DEB_TARGET_ARCH := $(DEBIAN_TARGET_FILE)
-    else
-      ifdef DEB_GCC_TARGET
-        DEB_TARGET_ARCH := $(DEB_GCC_TARGET)
-      else
-        DEB_TARGET_ARCH := $(DEB_HOST_ARCH)
-      endif
+# since dpkg 1.17.14, DEB_TARGET_* default to DEB_HOST_*
+DEB_TARGET_ARCH ?= $(DEB_HOST_ARCH)
+# allow debian/target to be used instead of DEB_GCC_TARGET - this was requested
+# by toolchain-source maintainer
+DEBIAN_TARGET_FILE := $(strip $(if $(wildcard debian/target),$(shell cat debian/target 2>/dev/null)))
+# consider DEB_TARGET_* set, if it differs from DEB_HOST_*
+ifeq ($(DEB_TARGET_ARCH),$(DEB_HOST_ARCH))
+  ifneq (,$(DEBIAN_TARGET_FILE))
+    DEB_TARGET_ARCH := $(DEBIAN_TARGET_FILE)
+  else
+    ifdef DEB_GCC_TARGET
+      DEB_TARGET_ARCH := $(DEB_GCC_TARGET)
     endif
   endif
-  TARGET_VARS := $(shell dpkg-architecture -f -a$(DEB_TARGET_ARCH) 2>/dev/null)
-endif
-ifeq ($(dpkg_target_vars),yes)
-  TARGET_VARS		:= $(filter-out DEB_TARGET_%, $(TARGET_VARS))
 endif
+TARGET_VARS := $(shell dpkg-architecture -f -a$(DEB_TARGET_ARCH) 2>/dev/null)
 
 DEB_TARGET_ARCH		:= $(call vafilt,$(TARGET_VARS),DEB_HOST_ARCH)
+DEB_TARGET_ARCH_BITS	:= $(call vafilt,$(TARGET_VARS),DEB_HOST_ARCH_BITS)
 DEB_TARGET_ARCH_OS	:= $(call vafilt,$(TARGET_VARS),DEB_HOST_ARCH_OS)
 DEB_TARGET_ARCH_CPU	:= $(call vafilt,$(TARGET_VARS),DEB_HOST_ARCH_CPU)
+DEB_TARGET_ARCH_ENDIAN	:= $(call vafilt,$(TARGET_VARS),DEB_HOST_ARCH_ENDIAN)
 DEB_TARGET_GNU_CPU	:= $(call vafilt,$(TARGET_VARS),DEB_HOST_GNU_CPU)
 DEB_TARGET_GNU_TYPE	:= $(call vafilt,$(TARGET_VARS),DEB_HOST_GNU_TYPE)
 DEB_TARGET_GNU_SYSTEM	:= $(call vafilt,$(TARGET_VARS),DEB_HOST_GNU_SYSTEM)
-- 
2.17.1

